/* Tabela TIPORPAT: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela GRUPOFISCAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela GRUPOFISCAL utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_PLA_TIPOPRAT
AFTER DELETE OR INSERT OR UPDATE
ON TIPOPRAT FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDTIPOPRAT  IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDTIPOPRAT;
      END IF;

      IF :OLD.NMTIPOPRAT IS NOT NULL THEN
         V_DESC := V_DESC || ' Nome=' || :OLD.NMTIPOPRAT;
      END IF;

      IF :OLD.IDSOBRLIMPTP  IS NOT NULL THEN
         V_DESC := V_DESC || ' SobraLimp=' || :OLD.IDSOBRLIMPTP;
      END IF;

      IF :OLD.IDMEDICAOKG IS NOT NULL THEN
         V_DESC := V_DESC || ' Medicao=' || :OLD.IDMEDICAOKG;
      END IF;

      IF :OLD.CDGRTIPOPR IS NOT NULL THEN
         V_DESC := V_DESC || ' Grupo=' || :OLD.CDGRTIPOPR;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDTIPOPRAT;
   ELSE
      IF UPDATING THEN

         IF NVL(:NEW.CDTIPOPRAT,'!')   <>  NVL(:OLD.CDTIPOPRAT,'!')   OR
            NVL(:NEW.NMTIPOPRAT,'!')   <>  NVL(:OLD.NMTIPOPRAT,'!')   OR
            NVL(:NEW.IDSOBRLIMPTP,'!') <>  NVL(:OLD.IDSOBRLIMPTP,'!') OR
            NVL(:NEW.IDMEDICAOKG,'!')  <>  NVL(:OLD.IDMEDICAOKG,'!')  OR
            NVL(:NEW.CDGRTIPOPR,'!')   <>  NVL(:OLD.CDGRTIPOPR,'!')     THEN

            IF NVL(:NEW.CDTIPOPRAT,'!') <>  NVL(:OLD.CDTIPOPRAT,'!') THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDTIPOPRAT;
            END IF;

            IF NVL(:NEW.NMTIPOPRAT,'!') <>  NVL(:OLD.NMTIPOPRAT,'!') THEN
               V_DESC := V_DESC || ' Nome=' || :NEW.NMTIPOPRAT;
            END IF;

            IF NVL(:NEW.IDSOBRLIMPTP,'!') <>  NVL(:OLD.IDSOBRLIMPTP,'!') THEN
               V_DESC := V_DESC || ' SobraLimp=' || :NEW.IDSOBRLIMPTP;
            END IF;

            IF NVL(:NEW.IDMEDICAOKG,'!') <>  NVL(:OLD.IDMEDICAOKG,'!') THEN
               V_DESC := V_DESC || ' Medicao=' || :NEW.IDMEDICAOKG;
            END IF;

            IF NVL(:NEW.CDGRTIPOPR,'!') <>  NVL(:OLD.CDGRTIPOPR,'!') THEN
               V_DESC := V_DESC || ' Grupo=' || :NEW.CDGRTIPOPR;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDTIPOPRAT;
         END IF;
      ELSE
         IF :NEW.CDTIPOPRAT  IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDTIPOPRAT;
         END IF;

         IF :NEW.NMTIPOPRAT IS NOT NULL THEN
            V_DESC := V_DESC || ' Nome=' || :NEW.NMTIPOPRAT;
         END IF;

         IF :NEW.IDSOBRLIMPTP  IS NOT NULL THEN
            V_DESC := V_DESC || ' SobraLimp=' || :NEW.IDSOBRLIMPTP;
         END IF;

         IF :NEW.IDMEDICAOKG IS NOT NULL THEN
            V_DESC := V_DESC || ' Medicao=' || :NEW.IDMEDICAOKG;
         END IF;

         IF :NEW.CDGRTIPOPR IS NOT NULL THEN
            V_DESC := V_DESC || ' Grupo=' || :NEW.CDGRTIPOPR;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDTIPOPRAT;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER,  DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('TIPOPRAT',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR,
                V_DSREMOTEHOST, V_DSSERVMETHOD,
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_TIPOPRAT','4.09.060'); END;
/

